Attribute VB_Name = "Module1"
Option Explicit

Public hMenu As Long, hSubMenu As Long

Public Enum MyVars
    PopUpYes = True
    PopUpNo = False
    InRootYes = True
    InRootNo = False
End Enum

Private Type MC
    Tag As String
    wParam As Long
End Type

Private Type PUM
    MenuCommand() As MC
    wParam As Long
End Type

Public MyPopUpMenu() As PUM

Public Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" _
    (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, _
    ByVal lpNewItem As Any) As Long
Public Declare Function GetSubMenu Lib "user32" _
    (ByVal hMenu As Long, ByVal nPos As Long) As Long
Public Declare Function CreatePopupMenu Lib "user32" () As Long
Public Declare Function DeleteMenu Lib "user32" _
    (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
    (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const MF_BITMAP = &H4&
Public Const MF_BYCOMMAND = &H0&
Public Const MF_CHECKED = &H8&
Public Const MF_DISABLED = &H2&
Public Const MF_GRAYED = &H1&
Public Const MF_MENUBARBREAK = &H20&
Public Const MF_MENUBREAK = &H40&
Public Const MF_OWNERDRAW = &H100&
Public Const MF_POPUP = &H10&
Public Const MF_SEPARATOR = &H800&
Public Const MF_STRING = &H0&
Public Const MF_UNCHECKED = &H0&
Public Const MF_BYPOSITION = &H400&
Public Const GWL_WNDPROC = (-4)
Public Const WM_MENUSELECT = &H11F
Public Const WM_COMMAND = &H111
Public Const MF_SYSMENU = &H2000&

Public Const MIIM_CHECKMARKS = &H8&
Public Const MIIM_DATA = &H20
Public Const MIIM_ID = &H2
Public Const MIIM_STATE = &H1&
Public Const MIIM_SUBMENU = &H4
Public Const MIIM_TYPE = &H10

Public origWndProc As Long

Public Sub SetHook(hwnd, bSet As Boolean)
    If bSet Then
        origWndProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf AppWndProc)
    ElseIf origWndProc Then
        Dim lRet As Long
        lRet = SetWindowLong(hwnd, GWL_WNDPROC, origWndProc)
        origWndProc = 0
    End If
End Sub

Public Function AppWndProc(ByVal hwnd As Long, ByVal msg As Long, _
                           ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim I As Integer
    Dim J As Integer
    
    Select Case msg
        Case WM_COMMAND
            For I = 0 To UBound(MyPopUpMenu)
                For J = 0 To UBound(MyPopUpMenu(I).MenuCommand)
                    If (MyPopUpMenu(I).MenuCommand(J).wParam = wParam) Then
                        'example to use with webbrowser
                        frmMain.WebBrowser1.Navigate2 MyPopUpMenu(I).MenuCommand(J).Tag
                    End If
                Next
            Next
    End Select
    AppWndProc = CallWindowProc(origWndProc, hwnd, msg, wParam, lParam)
End Function

Public Sub InitItem(ByVal Rootvalue As Integer, ByRef ItemValue As Integer, _
                        ByVal ItemCaption As String, ByVal Tag As String)
    ItemValue = 0
    ReDim Preserve MyPopUpMenu(Rootvalue)
    ReDim Preserve MyPopUpMenu(Rootvalue).MenuCommand(ItemValue)
    MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam = CreatePopupMenu()
        
    AppendMenu hSubMenu, MF_STRING, MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam, ItemCaption
                
    MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).Tag = Tag
End Sub

Public Sub InitPopUp(ByVal Rootvalue As Integer, ByRef ItemValue As Integer, _
                         ByVal ItemCaption As String)
    ItemValue = 0
    ReDim Preserve MyPopUpMenu(Rootvalue)
    MyPopUpMenu(Rootvalue).wParam = CreatePopupMenu()
    AppendMenu hSubMenu, MF_POPUP, MyPopUpMenu(Rootvalue).wParam, ItemCaption
End Sub
                         
Public Sub AddToMenu(ByVal Rootvalue As Integer, ByRef ItemValue As Integer, _
                     ByVal ItemCaption As String, ByVal Tag As String, _
                     ByVal IsPopUp As Boolean, ByVal InRoot As Boolean)
    
    ItemValue = ItemValue + 1
        
    ReDim Preserve MyPopUpMenu(Rootvalue).MenuCommand(ItemValue)
        
    MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam = CreatePopupMenu()
        
    If (IsPopUp) Then
            
        If (InRoot) Then
            AppendMenu MyPopUpMenu(Rootvalue).wParam, MF_POPUP, _
                       MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam, ItemCaption
        Else
            AppendMenu MyPopUpMenu(Rootvalue).MenuCommand(ItemValue - 1).wParam, MF_POPUP, _
                       MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam, ItemCaption
        End If
        
    Else
        
        If (InRoot) Then
            AppendMenu MyPopUpMenu(Rootvalue).wParam, MF_STRING, _
                       MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam, ItemCaption
        Else
            AppendMenu MyPopUpMenu(Rootvalue).MenuCommand(ItemValue - 1).wParam, MF_STRING, _
                       MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).wParam, ItemCaption
        End If
        MyPopUpMenu(Rootvalue).MenuCommand(ItemValue).Tag = Tag
    
    End If
End Sub

Public Sub KillMenu()
    Dim I As Integer
    Dim J As Integer

    For I = UBound(MyPopUpMenu) To 0 Step -1
        For J = UBound(MyPopUpMenu(I).MenuCommand) To 0 Step -1
            If (MyPopUpMenu(I).wParam > 0) Then
                DeleteMenu MyPopUpMenu(I).wParam, MyPopUpMenu(I).MenuCommand(J).wParam, MF_BYCOMMAND
            Else
                DeleteMenu hSubMenu, MyPopUpMenu(I).MenuCommand(J).wParam, MF_BYCOMMAND
            End If
        Next
        If (MyPopUpMenu(I).wParam > 0) Then
            DeleteMenu hSubMenu, MyPopUpMenu(I).wParam, MF_BYCOMMAND
        End If
    Next
    ReDim MyPopUpMenu(0)
End Sub
